; 14.11.2003: adapted to DASM by Thomas jentzsch

    processor 6502

;       llchar   '.'         ; prefix for local label types
;*******************************
;                              *
;          METEROIDS           *
;          VERSION 23          *
;                              *
;*******************************
;
;
;     FEBUARY 10, 1982
;
;
;      VCS SYSTEM EQUATES
;
VSYNC      EQU $0
VBLANK     EQU $1
WHSYNC     EQU $2
P1CONT     EQU $4
P2CONT     EQU $5
P1COLOR    EQU $6 ;
P2COLOR    EQU $7 ;
PFCOLOR    EQU $8
BCOLOR     EQU $9
PFCONT     EQU $A
PF1        EQU $D
PL1POS     EQU $10 ;
PL2POS     EQU $11 ;
S1TYPE     EQU $15 ;
S2TYPE     EQU $16 ;
S1PITCH    EQU $17 ;
S2PITCH    EQU $18 ;
S1VOL      EQU $19 ;
S2VOL      EQU $1A ;
PL1        EQU $1B
PL2        EQU $1C
P1SHFT     EQU $20 ;
P2SHFT     EQU $21 ;
SHIFT      EQU $2A ;
SZERO      EQU $2B
JSBTN1     EQU $3C ;
JSBTN2     EQU $3D ;
STICK      EQU $280 ;
CONSOLE    EQU $282
TIMER      EQU $284 ;
TIMERI     EQU $295
TIME64C    EQU $296 ;
TIME64CI   EQU $29E
TIME1KC    EQU $297 ;
;
;      CONSTANTS
;
RAM        EQU $F000
SET.STATUS EQU $FFF8
RESET      EQU $1
SELECT     EQU $2
LDIFF      EQU $40
RDIFF      EQU $80
VOLUME     EQU 10
MAX.LUM    EQU $F3
MAX.HIT    EQU $1F
MAX.MISS   EQU 4

;
;      ZERO PAGE USAGE
;
           seg.u   variables
           org $80
STATUS     ds  1
TEMP0      ds  1
TEMP1      ds  1
TEMP2      ds  1
TEMP3      ds  1
TEMP4      ds  1
TEMP5      ds  1
TEMPOBJ    ds  1
TEMPX      ds  1
TEMPY      ds  1
TEMPTY     ds  1
DX         EQU TEMP4
DY         EQU TEMP5
VERT       ds  1
ADR1       ds  2
ADR2       ds  2
ADR3       ds  2
ADR4       ds  2
SHAPES     ds  6
TAR        EQU SHAPES+0
TXR        EQU SHAPES+1
TYR        EQU SHAPES+2
OBJ        ds  1
SHIP.HIT   ds  1
ALIEN.FLAG ds  1
BUTTN.FLAG ds  1
STICK.FLAG ds  1
SCRN.FLAG  ds  1
LAST.OBJ   ds  1
OBJ.COUNT  ds  1
POWER      ds  1
SHIELDS    ds  1
NSTEP      ds  1
RATE       ds  1
HITS       ds  1
TYPE       ds  2
PITCH      ds  2
VOL        ds  2
MX         ds  MAX.MISS
MY         ds  MAX.MISS
MXF        ds  MAX.MISS
MYF        ds  MAX.MISS
MDX        ds  MAX.MISS
MDY        ds  MAX.MISS
MISS.DECAY ds  MAX.MISS
MISS.HIT   ds  MAX.MISS
SCORE1     ds  2
SCORE2     ds  2
SCORE3     ds  2
;
;      NON-DESTROYABLES
;
SHIP.ANGLE ds  1
PLAYER     ds  1
NSHIPS     ds  2
SVAL       ds  2
SVALI      ds  2
SHIP.DECAY ds  1
SET.PLAYER ds  1
CLOBJ      ds  1
OPTION     ds  1
LEVEL      ds  2
GAME       ds  1
CON.FLAG   ds  1
SEL.FLAG   ds  1
NPLAY      ds  1
RNDL       ds  1
RNDH       ds  1
FRAMEL     ds  1
FRAMEH     ds  1
BAK0       ds  1
BAK1       ds  1
BAK2       ds  1
BAK3       ds  1
BAK4       ds  1
ATTRACT    ds  1
ZPEND      EQU *
;
;
;
;
;
;      START OF PROGRAM
;
;
;
;
;
       seg CODE
       org $E800  ; RAM1
       rorg $f000  ; RAM1

R1START
;
;      DRAW 1ST SCREEN
;
DRAW1  LDA #$70
       STA P2SHFT
       LDX BAK2
0$     LDA TIMERI
       BPL 0$
       STA WHSYNC
       STX BCOLOR
       NOP
       LDX #7
1$     DEX
       BNE 1$
       STA PL2POS
       STA WHSYNC
       STA SHIFT
       STA WHSYNC
       STA SZERO
       LDA #$E0
       STA P1SHFT
;      BLANK
2$     STA WHSYNC
       LDX #0
       STX PL1
       STX PL2
       DEC VERT
       BMI 4$
       LDY VERT
       LDA TB3,Y
       STA PL1POS
       STA TEMP0
       LDA #3
       STA P1CONT
       LDA TB5,Y
       STA TEMP1
       LDA TB11,Y
       STA TEMP2
       LDA TB13,Y
       STA TEMP3
       LDA TB15,Y
       STA TEMP4
       LDA TB17,Y
       STA TEMP5
       LDX TB9,Y
;      NON-BLANK
       CPY #79
       BEQ 3$
       STA SHIFT
       LDA TB1,Y
       STA PL1
       LDA TB7,Y
       STA PL2
       LDA TB3,Y
       LDY TEMP3
       LDY TEMP3
       STA PL1
       LDA TEMP1
       STA PL1
       LDA #6
       STA P1CONT
       STX PL1
       STA PL1POS
       LDA TEMP2
       STA PL2
       STY PL1
       LDA TEMP4
       STA PL2
       LDA TEMP5
       STA PL1
       JMP 2$
3$     LDA BAK4
       STA P1COLOR
       STA P2COLOR
       LDA BAK3
       STA BCOLOR
       JMP 2$
4$     LDA BAK0
       STA BCOLOR
TIMER1 LDX #55
       STX TIME64CI
       RTS
;
;      DRAW 2ND SCREEN
;
DRAW2  LDA #$40
       STA P2SHFT
       LDX BAK2
0$     LDA TIMERI
       BPL 0$
       STA WHSYNC
       STX BCOLOR
       NOP
       LDY #5
1$     DEY
       BNE 1$
       STA PL2POS+$100
       STA WHSYNC
       STA SHIFT
       STA WHSYNC
       STA SZERO
       LDA #$50
       STA P1SHFT
       TSX
       STX TEMP0    ; STACK SAVE
2$     STA WHSYNC
       LDX #0
       STX PL1
       STX PL2
       DEC VERT
       BMI 4$
       LDY VERT
       LDA #6
       STA P1CONT
       LDA TB8,Y
       STA PL1POS
       STA TEMP1
       LDA TB10,Y
       STA TEMP2
       LDA TB12,Y
       STA TEMP3
       LDX TB16,Y
       CPY #79
       BEQ 3$
       STA WHSYNC
       STA SHIFT
       TXS
       NOP
       LDX TB14,Y
       LDA TB2,Y
       STA PL1
       LDA TB4,Y
       STA PL2
       LDA TB6,Y
       LDY #3
       STA PL1
       LDA TEMP1
       STA PL2
       LDA TEMP2
       STA PL1
       LDA TEMP3
       STA PL2
       STA PL1POS
       STY P1CONT
       STX PL1
       TSX
       STX PL1
       JMP 2$
3$     LDA BAK4
       STA P1COLOR
       STA P2COLOR
       LDA BAK3
       STA WHSYNC
       STA BCOLOR
       JMP 2$
4$     LDA BAK0
       STA BCOLOR
       LDX TEMP0    ; STACK SAVE
       TXS
TIMER2 LDX #55
       STX TIME64CI
       RTS
;
;      RESET SCREEN
;      AND PRIORITY TABLES
;
RESET.SCREEN
       JSR SCREEN
       LDA #0
       STA S1VOL
       STA S2VOL
       LDX #>TB1
       LDY #<TB1
       STA ADR1
       STX ADR1+1
1$     LDA RAM+0
       LDA (ADR1),Y ; RAM!
       INY
       TYA
       AND #$7F
       BNE 1$
       JSR SCREEN
       TYA
       BNE 1$
       INC ADR1+1
       LDA ADR1+1
       CMP #>(TB17+86)
       BNE 1$
RESET.TABLES
       JSR SCREEN
       LDY #30
1$     LDA RAM+$FF
       NOP
       LDA TY,Y    ; RAM!
       LDA RAM+$FF
       NOP
       LDA PRI1,Y  ; RAM!
       DEY
       BPL 1$
       LDY #9
2$     LDA RAM+$C
       NOP
       LDA PRI4,Y  ; RAM!
       DEY
       BPL 2$
       JSR SCREEN
       LDA #$5A
       STA BAK1
       LDA #$82
       STA BAK2
       LDA #$F
       STA BAK4
       LDX #SCORE1-2
       LDA #0
3$     STA $1,X
       DEX
       BMI 3$
       LDA #<(TB1+80)
       STA ADR1
       LDA #>TB1
       STA ADR1+1
       JSR DPLAY
       LDA #<(TB17+80)
       STA ADR1
       LDA #>TB17
       STA ADR1+1
       LDA #0      ; NUMBER "0"
       JSR DRAW
       JMP SCREEN  ; RTS!
;
;      RESET SHIP TO MIDDILE
;      OF SCREEN AND STOP
;      IT FROM MOVING
;
ISHP   JSR DNSHIP
       LDA #$1F
       STA POWER
;
; THIS CODE USES A FUNNY
; PAGE CROSSING TECHNIC TO
; FORCE A ADDRESS TRANSISION
; THUS REPLACING THE NOP
;
       LDX #$FF
       LDA RAM+1,X
       LDA TY       ; RAM!
       JSR RND
       AND #31
       STA SHIP.ANGLE
       LDA RAM+5,X
       LDA ODX      ; RAM!
       LDA RAM+5,X
       LDA ODY      ; RAM!
       LDA RAM+65,X
       LDA OBX      ; RAM!
       LDA RAM+43,X
       LDA OBY      ; RAM!
       LDY #0
       STY TEMP4
       JMP USHP1
;
;      DRAW N SHIPS
;      FOR PLAYER X
;
DNSHIP LDA #<(TB1+5)
       STA ADR1
       LDA #>TB1
       STA ADR1+1
       LDX PLAYER
       LDY NSHIPS,X
       DEY
       BEQ 3$
       STY TEMP0
1$     LDY #5
2$     LDX SHIP+54,Y
       LDA RAM,X
       LDA (ADR1),Y ; RAM!
       DEY
       BPL 2$
       LDA ADR1
       CLC
       ADC #8
       STA ADR1
       DEC TEMP0
       BNE 1$
3$     LDA #<(TB1+79)
       SEC
       SBC ADR1
       TAY
4$     LDA RAM+0
       LDA (ADR1),Y ; RAM!
       DEY
       BPL 4$
       RTS
;
;      GENERATE SYNC
;      AND DO SHIP FRICTION
;
SYNC   JSR USR
1$     LDA TIMERI
       BPL 1$
       LDA #2
       STA WHSYNC
       STA VBLANK
       STA VSYNC
       JSR RND
2$     STA WHSYNC
       LDA SCRN.FLAG
       BNE SYNC1
       LDA FRAMEL ;
       AND #31
       BNE SYNC1
       STA WHSYNC
       LDA ODX
       CMP #4
       BEQ SYDY ;
       CLC
       BIT FOUR
       BNE SY3
       ADC #$10
       ADC #$0
       TAX
       LDA RAM,X
       NOP
       LDA ODX      ; RAM!
       JMP SYDY
SY3    ADC #$F0
       ADC #$FF
       TAX
       LDA RAM,X
       NOP
       LDA ODX      ; RAM!
SYDY   STA WHSYNC
       LDA ODY
       CMP #4
       BEQ SYNC2
       CLC
       BIT FOUR
       BNE SY4
       ADC #$10
       ADC #$0
       TAX
       LDA RAM,X
       NOP
       LDA ODY      ; RAM!
       JMP SYNC2
SY4    ADC #$F0
       ADC #$FF
       TAX
       LDA RAM,X
       NOP
       LDA ODY      ; RAM!
       JMP SYNC2
SYNC1  STA WHSYNC
       STA WHSYNC
SYNC2  STA WHSYNC
       LDA #0
       STA VSYNC
       STA WHSYNC
       STA WHSYNC
       LDA BAK0
       STA PFCOLOR
       STA BCOLOR
       LDA BAK1
       STA P1COLOR
       STA P2COLOR
       LDX PLAYER
       LDY ATTRACT
       BEQ SY5
       LDA LEVEL,X
       AND #MAX.LEVELS
       TAY
       LDX COLORS,Y
       STX BAK3
SY5    STA WHSYNC
       LDA #85      ; BIT 1 = 0
       STA VBLANK
       STA VERT
TIMER3 LDA #41
       STA TIME64CI
       RTS
;
;      A FOUR FOR FRICTION
;
; FOUR EQU A 4 IN SHIP SHAPE
;
;      CHECK IF AN
;      ALIEN CAN BE CREATED.
;      MAKE ALIEN SOUND.
;      MOVE ALIEN.
;
ALIEN  LDA ALIEN.FLAG
       BNE ALIEN2
       LDA TEMPTY
       BNE 1$
       JSR RND
       CMP FRAMEL
       BNE 1$
       LDA FRAMEH
       AND #3
       BNE 1$
;      LDA #0
       STA TEMPY
       JSR RND
       AND #$7F
       STA TEMPX
       LDA #$FF
       STA LAST.OBJ
       JSR SCREEN
       JSR ALIEN.SWAP
       BCS 1$
       JSR SCREEN
       JSR DROBJ2
       SEC            ; SET ALIEN
       ROR ALIEN.FLAG ; SET FLAG
1$     RTS
;
;      MAKE ALIEN SOUND
;
ALIEN2 LDA FRAMEL
       ASL
       AND #7
       SEC
       SBC #255-31
       STA PITCH+1
       LDA #12
       STA TYPE+1
       LDA #VOLUME-5
       STA VOL+1
ALRTS  RTS
;
;      READ CONSOLE SWITCHES
;      AND DO SOMETHING
;
USR    LDA SCRN.FLAG
       BNE ALRTS
       LDX CONSOLE
       CPX CON.FLAG
       BEQ 3$
       STX CON.FLAG
       TXA
       AND #RESET
       BNE 2$
;      LDA #0
       STA SET.PLAYER
       LDX #GAME-2
1$     STA $1,X
       DEX
       BMI 1$
       INC PLAYER  ; PLAYER=1
       LDX #$FF
       TXS
       STX SHIP.ANGLE
       STX ATTRACT
       STX SEL.FLAG
       JSR SCREEN
       JSR SETOPT.SWAP
       JMP MAIN
2$     TXA
       AND #SELECT
       BNE 3$
       JMP SELECT.SWAP
3$     TXA
       LDX OPTION
       LDY PLAYER
       AND DIFF,Y
       BEQ 4$
       TXA
       ORA #$80
       BMI 5$      ; FORCED
4$     TXA
       AND #$7F
5$     STA OPTION
;
;      ATTRACT MODE
;
ATT    LDA ATTRACT
       BNE 1$
       LDA FRAMEL
       BNE 1$
       INC FRAMEL
       JSR RND
       AND #MAX.LUM
       STA BAK3
       EOR #MAX.LUM
       STA BAK2
1$     RTS
;
;      UPDATE SHIP
;      OR RESET IT AFTER
;      A KILL
;
USHP   LDA ATTRACT
       BEQ 1$
       LDA SHIP.ANGLE
       CMP #$FF
       BNE DSHP
       LDA SET.PLAYER
       BNE 3$
       LDX #MAX.MISS-1
0$     LDA MISS.DECAY,X
       BNE 4$
       DEX
       BPL 0$
       LDA #70
       STA SET.PLAYER
       STA SHIP.DECAY
       LDA PLAYER
       EOR #1
       AND NPLAY
       STA PLAYER
       TAX
       LDA NSHIPS,X
       BNE 2$
       TXA
       EOR #1
       TAX
       LDA NSHIPS,X
       BNE 2$
;      LDA #0
1$     STA ATTRACT
4$     RTS
2$     STX PLAYER
       LDA LEVEL,X
       STA CLOBJ
       JSR RESET.SCREEN
       JMP DNSHIP
3$     LDA SHIP.DECAY
       BEQ 5$
       DEC SHIP.DECAY
       BNE 4$
5$     JMP ISHP
;
;      DRAW SHIP
;
DSHP   LDA #1
       STA TEMP4
USHP1  LDY #0
       STY SHIP.HIT
       JSR DROBJ2
       LDA #SZVSHP
       STA TEMP1
       LDA SHIP.ANGLE
       AND #$7E
       STA TEMP3
       ASL
       ADC TEMP3
       STA TEMP3
SHP0   LDY TEMP3
       LDA SHIP,Y
       STA TEMP2
       LDA #0
       LDX TEMP0
       BEQ SHP1
SHFT   LSR TEMP2
       ROR
       DEX
       BNE SHFT
SHP1   INC TEMP3
       LDY TEMP1
       STA TEMP5
       EOR (ADR2),Y
       TAX
       LDA RAM,X
       LDA (ADR2),Y ; RAM!
       AND TEMP5
       BEQ SHP2
       STA SHIP.HIT
SHP2   LDA TEMP2
       EOR (ADR1),Y
       TAX
       LDA RAM,X
       LDA (ADR1),Y ; RAM!
       AND TEMP2
       BEQ SHP3
       STA SHIP.HIT
SHP3   DEC TEMP1
       BPL SHP0
       DEC TEMP4
       BPL SHP3.5
SHP3.4 RTS
SHP3.5 LDX SHIP.ANGLE
       BPL SHP3.7
       INX
       INX
       CPX #128+44
       BCC SHP3.6
       LDX #$FF
SHP3.6 STX SHIP.ANGLE
       CPX #$FF
       BEQ SHP3.4
       BNE SHP3.9   ; FORCED
;
;      COLLISIONS?
;
SHP3.7 LDA SHIP.HIT
       BEQ SHP4 ;
;
;      A HIT!
;
       LDA SHIELDS
       BNE SHP4
SHP3.8 LDX PLAYER
       DEC NSHIPS,X
       JSR XPLOS.SWAP
       LDA #128
       STA SHIP.ANGLE
       ASL         ; A=0
       STA BAK0
       STA SET.PLAYER
SHP3.9 JMP SHP9
;
;      PRESS BUTTON?
;
SHP4   LDX PLAYER
       LDY JSBTN1,X
       BPL 1$
       STY BUTTN.FLAG
       BNE 3$      ; FORCED
1$     LDA FRAMEL
       AND #1
       BEQ 3$
       LDA OPTION
       BPL 0$
       BIT BUTTN.FLAG
       BPL 3$
       STY BUTTN.FLAG
0$     LDY #MAX.MISS-1
2$     LDA MISS.DECAY,Y
       BEQ 4$
       DEY
       BPL 2$
3$     JMP SHP5
4$     STY OBJ
       LDA SHIP.ANGLE
       LSR
       TAX
       LDA MOSX,X
       CLC
       ADC OBX
       STA MX,Y
       LDA MOSY,X
       CLC
       ADC OBY
       STA MY,Y
       LDA ODX      ; GET SHIP DX AND
       LSR          ; DIVIDE BY 2
       LDA ODX      ; GET CARRY AND
       ROR          ; BRING IT BACK IN
       CLC          ; AND ADD IT TO DX
       ADC MTHX,X   ; FOR SHIP ANGLE
       ADC #$FE     ; SUB 2 (FROM /2)
       AND #$F7     ; REMOVE INFINITE
       STA MDX,Y    ; VALUE
       LDA ODY
       LSR
       LDA ODY
       ROR
       CLC
       ADC MTHY,X
       ADC #$FE
       AND #$F7
       STA MDY,Y
       JSR SHIP.SWAP
DECAY  LDA #19
       STA MISS.DECAY,Y
       LDA #4
       STA TYPE
       LDA #255-20
       STA PITCH
       LDA #VOLUME
       STA VOL
;
;      READ STICK
;
SHP5   LDX STICK
       LDY PLAYER
       TXA
       AND PRIGHT,Y
       BNE SHP6
       INC SHIP.ANGLE
SHP6   TXA
       AND PLEFT,Y
       BNE SHP7
       DEC SHIP.ANGLE
SHP7   LDA SHIP.ANGLE
       AND #31
       STA SHIP.ANGLE
;
;      CHECK WHICH OPTION
;
OPT    LDA OPTION
       AND #1
       BEQ CLOAK
       JMP SHIELD
;
;      CLOAK
;
CLOAK  TXA
       AND PBWD,Y
       BNE 2$
;      LDA #0
       STA BAK0
       LDA STICK.FLAG
       BNE 3$
       LDA #$CF ; SET STICK FLAG
       STA BAK0 ; AND CHANGE BAK0
       STA STICK.FLAG
       LDA POWER
       BPL 1$
       JMP SHP3.8   ; DEAD
1$     LDA #1
       STA TYPE
       LDA #255-31
       STA PITCH
       LDA #VOLUME
       STA VOL
       LDA POWER
       SEC
       SBC #8
       STA POWER
       JSR RND
       AND #$7F
       TAX
       LDA RAM,X
       NOP
       LDA OBX      ; RAM!
       JSR RND
       LDA RNDH
       AND #$3F
       TAX
       LDA RAM,X
       NOP
       LDA OBY      ; RAM!
       BPL 3$       ; FORCED
2$     LDA #0
       STA BAK0
       STA STICK.FLAG
3$     LDA #0
       STA SHIELDS
       JMP SHP8
;
;      SHIELDS
;
SHIELD TXA
       AND PBWD,Y
       BNE 1$
       LDA #4
       STA TYPE
       STA SHIELDS
       LDA POWER
       CLC
       ADC #$80
       STA PITCH
       LDA #$80+VOLUME
       STA VOL
       LDA FRAMEL
       AND #6
       BNE 2$
       DEC POWER
       BNE 3$
       JMP SHP3.8   ; DEAD
1$     LDA #0
       STA SHIELDS
       LDA FRAMEL
       AND #126
       BNE 2$
       LDA POWER
       CMP #$1F
       BEQ 2$
       INC POWER
2$     LDA POWER
       LSR
       STA BAK0
       LDA #$0F
       SEC
       SBC BAK0
       STA BAK0
3$
;
;      THRUST?
;
SHP8   TXA
       AND PFWD,Y
       BNE SHP9 ;
       LDA #8
       STA TYPE+1
       LDA #$1F
       STA PITCH+1
       LDA #VOLUME+128
       STA VOL+1
       LDA FRAMEL
       AND #6 ;
       BNE SHP9
;
;      MOVE SHIP
;
       LDA SHIP.ANGLE
       LSR
       TAY
       LDA THX,Y
       CLC
       ADC ODX
       SBC #3
       BIT EIGHT
       BNE SHP8.5
       TAX
       LDA RAM,X
       NOP
       LDA ODX      ; RAM!
SHP8.5 LDA THY,Y
       CLC
       ADC ODY
       SBC #3
       BIT EIGHT
       BNE SHP9
       TAX
       LDA RAM,X
       NOP
       LDA ODY      ; RAM!
SHP9   LDY #0
       JSR XYINC
       JMP USHP1
;
;      AN EIGHT FOR SHIP
;
; EIGHT EQU AN 8 IN SHIP SHAPE
;
;      SHAPE FOR PLAYER SHIP
;
SZHSHP EQU 7
SZVSHP EQU 5
SHIP   hex 102828445482      ; 0
EIGHT  hex 081424449404      ; 1
       hex 020C34C42808      ; 2
       hex 00AA24281020      ; 3
       hex 00C0282228C0      ; 4
       hex 20102824AA00      ; 5
       hex 0828C4340C02      ; 6
FOUR   hex 049444241408      ; 7
       hex 825444282810      ; 8
       hex 405244485020      ; 9
       hex 202846586080      ; 10
       hex 08102848AA00      ; 11
       hex 062888280600      ; 12
       hex 00AA48281008      ; 13
       hex 806058462820      ; 14
       hex 205048445240      ; 15
       hex 102828447C92      ; E1
       hex 104848547491      ; E2
       hex 108484547C81      ; E3
       hex 488010A4B420      ; E4
       hex 008808007220      ; E5
       hex 000000000000      ; E6
;
;      THETA X,Y FOR MISSILES
;
MTHX   hex 04840585
;      hex 85850584
;      hex 04830382
;      hex 82820383
MTHY   hex 85850584
       hex 04830382
       hex 82820383
       hex 04840585
;
;      OFFSET FOR MISSILES
;
MOSX   hex 03060808080808060300
       hex FFFEFEFEFF01
MOSY   hex 060506050201FF00FF00
       hex FF0103060606
;
;      TABLE FOR PLAYERS
;      JOYSTICKS
;
PRIGHT hex 8008
PLEFT  hex 4004
PBWD   hex 2002
PFWD   hex 1001
DIFF   hex 4080
;
;      THETA X,Y FOR SHIP MOVE
;
THX    hex 04142434
;      hex 34342414
;      hex 04F3E3D3
;      hex D3D3E3F3
THY    hex 34342414
       hex 04F3E3D3
       hex D3D3E3F3
       hex 04142434
;
;      DRAW SCORE, NULL ZERO
;      DRAWN IN INITALIZATION
;      OR DRAW SELECT INFO
;
SCOREN LDA SEL.FLAG
       BEQ DSEL
;
DNUM   LDA #<(TB11+80)
       STA ADR1
       LDA #>TB11
       STA ADR1+1
       LDA #0
       STA TEMP2
       LDX PLAYER
       LDY SCORE3,X
       JSR DDIG
       LDY SCORE2,X
       JSR DDIG
       LDY SCORE1,X
;
DDIG   LDA TEMP2
       BNE DG1
       TYA
       AND #$F0
       BNE DG1
       TYA
       ORA #$A0
       TAY
       BNE DG2
DG1    LDA #$FF
       STA TEMP2
DG2    LDA TEMP2
       BNE DG3
       TYA
       AND #$0F
       BNE DG3
       TYA
       ORA #$0A
       TAY
       BNE DG4
DG3    LDA #$FF
       STA TEMP2
DG4    TYA
;
DDIG1  STA TEMP1
       LSR
       LSR
       LSR
       LSR
       JSR DRAW
       LDA TEMP1
       AND #$F
       JMP DRAW    ; RTS!
;
DSEL   LDA FRAMEL
       AND #31
       BEQ 1$
       LDA #<(TB4+37)
       STA ADR1
       LDA >#TB4
       STA ADR1+1
       LDX NPLAY   ; DRAW NUMBER
       INX
       TXA
       JSR DRAW    ; PLAYERS
       JSR BLANK   ; AND A SPACE
       LDX #$B     ; DRAW
       LDY #$D+1    ; "PLAYER"
       JSR DCHR
       JSR BLANK   ; AND A BLANK
       LDX #$11
       LDY #$12+1   ; "GAME"
       JSR DCHR
       JSR BLANK   ; AND A BLANK
       LDA GAME    ; DRAW GAME
       JMP DRAW    ; NUMBER
1$     RTS
;
DPLAY  LDX #$B     ; DRAW "PLAYER"
       LDY #$D+1
       JSR DCHR
       JSR BLANK   ; AND A SPACE
       LDX PLAYER  ; DRAW PLAYER
       INX
       TXA
       JSR DRAW    ; NUMBER
       LDX #$E     ; DRAW "SCORE"
       LDY #$10+1
;
DCHR   STY TEMP0
1$     TXA
       JSR DRAW
       INX
       CPX TEMP0
       BCC 1$
       RTS
;
BLANK  LDA #$A     ; SPACE
;
DRAW   STX TEMP3
       STA VERT
       ASL
       ASL
       ADC VERT
       ADC #4
       STA VERT
       LDY #4
1$     LDX VERT
       LDA CHAR,X
       TAX
       LDA RAM,X
       LDA (ADR1),Y ; RAM!
       DEC VERT
       DEY
       BPL 1$
       LDA ADR1
       CLC
       ADC #85
       STA ADR1
       BCC 2$
       INC ADR1
       INC ADR1+1
2$     LDX TEMP3
       RTS
;
;      COLORS FOR BACKGROUND
;
COLORS hex 00120282C0627082
       hex 404252E03252E4F0
MAX.LEVELS EQU $0F
;
;      SHAPES FOR CHARACTERS
;
CHAR   hex 7884848478 ; "00"   0
       hex 7C10103010 ; "11"   1
       hex FC40388478 ; "22"   2
       hex 78841C08FC ; "33"   3
       hex 1010F89080 ; "44"   4
       hex F804F880FC ; "55"   5
       hex 7884F8403C ; "66"   6
       hex 101008847C ; "77"   7
       hex 7884788478 ; "88"   8
       hex 10087C8478 ; "99"   9
       hex 0000000000 ; "  "   A
       hex 8E88C8A8C8 ; "PL"   B
       hex A4A4E4AA4A ; "AY"   C
       hex EA8ACC8AEC ; "ER"   D
       hex 0E0204080E ; " S"   E
       hex 648A8A8A64 ; "CO"   F
       hex AEA8CCA8CE ; "RE"  10
       hex 6595B78572 ; "GA"  11
       hex 5754567457 ; "ME"  12
;      hex 44AAAAAA4A "OV"
;      hex AEA4E4A4AE "HI"
R1END  EQU .
;
;      RAM2
;
       ORG $F000,0  ; RAM2
       RORG $f000  ; RAM1
R2START
;
;      ALIEN MOVEMENT
;
ALM    LDY OBJ
       LDA #4
       STA DX
       STA DY
       LDA OBX
       CMP OBX,Y
       BCS 1$
       LDA #2
       STA DX
       BNE 2$       ; FORCED
1$     LDA OBX
       CMP OBX,Y
       BEQ 2$
       BCC 2$
       LDA #6
       STA DX
2$     LDA OBY
       CMP OBY,Y
       BCS 3$
       LDA #2
       STA DY
       BNE 4$       ; FORCED
3$     LDA OBY
       CMP OBY,Y
       BEQ 4$
       BCC 4$
       LDA #6
       STA DY
4$     RTS
;
;      BACKGROUND IRRITATION
;
BKG    LDA RATE
       BNE 1$
       LDA NSTEP
       INC NSTEP
       AND #7
       TAY
       LDA PITCH+1
       BMI 1$
       LDA NOTES,Y
       STA PITCH+1
       LDA #VOLUME+128
       STA VOL+1
       LDA #12
       STA TYPE+1
1$     DEC RATE
       RTS
NOTES  hex 17171A1A1D1D1F1F
;
;      DO SOUNDS
;
SOUND  LDX #1
       LDA ATTRACT
       BEQ SO5
SO1    LDA VOL,X
       AND #$7F
       BEQ SO5
       LDA PITCH,X
       AND #$7F
       BEQ SO5
       LDA TYPE,X
       STA S1TYPE,X
       LDA VOL,X
       BPL SO2
       DEC VOL,X
SO2    STA S1VOL,X
       LDA PITCH,X
       BPL SO3
       INC PITCH,X
SO3    STA S1PITCH,X
SO4    DEX
       BPL SO1
       RTS
SO5    STA S1VOL,X  ; A=0
       BEQ SO4      ; FORCED
;
;      SELECT HAS BEEN
;      PRESSED, DO SOMETHING
;
RSEL   LDX #0
       STX SEL.FLAG
       STX ATTRACT
       STX BAK0
       LDX NPLAY
       INX
       CPX #2
       BCC 1$
       LDX #0
1$     STX NPLAY
       BCC 3$
       LDX GAME
       INX
       CPX #5
       BCC 2$
       LDX #1
2$     STX GAME
3$     RTS
;
;      SET OPTIONS
;      AND START GAME
;
SETOPT LDX GAME
       LDY #0
       LDA OPTV-1,X
       BPL 1$
       LDY #1
1$     STY OPTION
       AND #$7F
       STA TEMP0
       LDX NPLAY
2$     LDA TEMP0
       STA SVAL,X
       STA SVALI,X
       LDA #4
       STA LEVEL,X
       STA NSHIPS,X
       DEX
       BPL 2$
       STA CLOBJ
       RTS
OPTV   .byte #$5+$80  ; SHIELDS ARE
       .byte #$10+$80 ; SCORE+$80
       .byte #$5
       .byte #$10
;       .AS /HI ; ACTIVISION/
;       .AS / ; AND ATARI/
        align 256    ; SKIP TO $F100
;
;      CHECK FOR BLANK-FIELD
;      AND FILL IT IF POSSIBLE
;
CHECK  LDA ATTRACT
       BEQ 5$
0$     LDA TEMPTY
       BNE 4$
       LDA CLOBJ
       BNE 10$
       LDY #9
       CLC
       LDA #0
1$     ADC PRI4,Y
       DEY
       BPL 1$
       CMP #120
       BNE 3$
       LDX PLAYER
       INC LEVEL,X
       LDA LEVEL,X
       STA CLOBJ
       LDA #0
       STA HITS
3$     RTS
4$     JMP CRAST
5$     JSR DSCORES
10$    LDA FRAMEL
       AND #31
       BNE 3$
;      LDA #0
       STA TEMPX
       STA TEMPY
       DEC CLOBJ
       LDA #$FF
       STA LAST.OBJ
       JSR CLGAST
       BCS 12$
       JSR DROBJ
12$    PLA
       PLA
       JMP MAIN1
;
;      RANDOM ANGLES
;
ANGLES hex 0503848334850602
NANG   EQU 7
;
;      UPDATE MISSILES
;
MISMV  LDA TEMPTY
       BNE 4$
       LDA SEL.FLAG
       BEQ 5$
       LDX #MAX.MISS-1
1$     LDA MISS.HIT,X
       BNE SPAST
       DEX
       BPL 1$
       LDY #MAX.MISS-1
2$     LDA MISS.DECAY,Y
       BEQ 3$
       JSR DROM
3$     DEY
       BPL 2$
5$     RTS
4$     JMP CRAST
;
;      SPLIT AN ASTEROID
;
SPAST  LDA #0
       STA MISS.HIT,X
       STA MISS.DECAY,X
       STX TEMP0
       LDY #31
1$     DEY
       BEQ SPEND
       LDX TEMP0
       LDA TY,Y
       BMI 1$
       LDA MX,X
       CLC
       ADC #1
       SEC
       SBC OBX,Y
       AND #$7F
       LDX TY,Y
       CMP SIZEH,X
       BCS 1$
       LDX TEMP0
       LDA MY,X
       SEC
       SBC OBY,Y
       LDX TY,Y
       CMP SIZEV,X
       BCS 1$
SP0    JSR DROBJ
       LDA TY,Y
       STA TEMPTY
       STY TEMPOBJ
       LDA RAM+$FF
       NOP
       LDA TY,Y    ; RAM!
       LDA OBX,Y
       STA TEMPX
       LDA OBY,Y
       STA TEMPY
SPEND  RTS
;
;
;
CRAST  LDA TEMPOBJ
       LDY #29
SP1    CMP PRI1,Y
       BEQ SP2
       DEY
       BPL SP1     ; FORCED
1$     BNE 1$      ; JUST IN CASE
SP2    LDA RAM+$FF
       NOP
       LDA PRI1,Y   ; RAM!
       TYA
SP2.5  SEC
       SBC #10
       BPL SP2.5
       CLC
       ADC #10
       TAX
       CLC
       LDY TEMPTY
       LDA PRIT,Y
       ADC PRI4,X
       TAY
       LDA RAM,Y
       NOP
       LDA PRI4,X   ; RAM!
;
;      AN OBJECT HAS BEEN HIT
;      NOW DO THE PROPER THING
;
       LDX HITS
       INX
       CPX #MAX.HIT
       BCC 1$
       LDX #MAX.HIT
1$     STX HITS
       LDY TEMPTY
       DEY          ; SMALL AST (1)
       BNE SP3
       LDX #$10
       BNE SP7      ; FORCED
SP3    DEY          ; MEDIMUM AST (2)
       BNE SP4
       JSR CSMAST
       LDX #5
       LDY #0
       BEQ SP7      ; FORCED
SP4    DEY          ; LARGE AST (3)
       BNE SP5
       JSR CMDAST
       LDX #2
       LDY #0
       BEQ SP7      ; FORCED
SP5    DEY          ; ALIEN (4)
       LDX #$20
       STY ALIEN.FLAG ; CLR FLAG
SP7    LDA #0
       STA TEMPTY
;
;      INCREMENT SCORE WITH
;      X HAS LOW VALUE
;      Y HAS HIGH VALUE
;      TO ADD.
;
ISCORE SED
       CLC
       TXA
       LDX PLAYER
       ADC SCORE1,X
       STA SCORE1,X
       TYA
       ADC SCORE2,X
       STA SCORE2,X
       LDA SCORE3,X
       ADC #0
       STA SCORE3,X
       CLD
XPLOS  LDA #8
       STA TYPE+1
       LDA #255-15
       STA PITCH+1
       LDA #VOLUME
       STA VOL+1
       RTS
;
;      ADD ANOTHER SHIP
;      IF POSSIBLE
;
SCORE  LDX PLAYER
       LDA SVAL
       CMP SCORE2,X
       BNE 2$
       SED
       CLC
       ADC SVALI
       STA SVAL
       CLD
       LDY PLAYER
       LDX NSHIPS,Y
       INX
       CPX #11
       BCS 1$
       STX NSHIPS,Y
       JSR NSHIP.SWAP
       LDA #4
       STA TYPE+1
       LDA #$80+$1F
       STA PITCH+1
       LDA #VOLUME
       STA VOL+1
1$     RTS
2$     JMP SCORE.SWAP
;
;      DRAW SCORES
;
DSCORES
       LDA FRAMEL
       EOR #$FF
       AND #$3F
       BNE 1$
       LDA SEL.FLAG
       BEQ 1$
       LDX #<DPLAY
       LDA RAM,X
       NOP
       LDA SWAP.CHANGE1   ; RAM!
       LDX #>DPLAY
       LDA RAM,X
       NOP
       LDA SWAP.CHANGE1+1 ; RAM!
       LDA #<(TB1+80)
       STA ADR1
       LDA >#TB1
       STA ADR1+1
       LDA PLAYER
       EOR #1
       AND NPLAY
       STA PLAYER
       JSR DPLAY.SWAP
       LDX #<DNSHIP
       LDA RAM,X
       NOP
       LDA SWAP.CHANGE1  ; RAM!
       LDX #>DNSHIP
       LDA RAM,X
       NOP
       LDA SWAP.CHANGE1+1 ; RAM!
1$     RTS
;
;      CREATE THINGS
;      SML ASTEROIDS, ALIENS
;
CSMAST LDX #1
       BPL CREAT2   ; FORCED
CMDAST LDX #2
       BPL CREAT2   ; FORCED
CLGAST LDX #3
       BPL CREAT1   ; FORCED
CAL    LDX #4
       BPL CREAT1   ; FORCED
CREAT2 STX TEMP2
       JSR CROBJ
       BCS CRE1
       LDX TEMP2
CREAT1 JSR CROBJ
       BCC CRE1
       LDY LAST.OBJ
       BMI CRE1
       LDA TY,Y
       BMI CRE1
       JSR DROBJ
       SEC
CRE1   RTS
;
;
CROBJ  LDA PRIT,X
       STA TEMP0
       STX TEMP1
;
;
FREOBJ LDY #9
FR0    LDA PRI4,Y
       CMP TEMP0
       BCS FR1
       DEY
       BPL FR0
       BNE FR9     ; FORCED
FR1    LDX #0
       LDA PRI1,Y
       BMI FR3
       LDX #10
       LDA PRI2,Y
       BMI FR3
       LDX #20
       LDA PRI3,Y
       BMI FR3
FR2    DEY
       BPL FR0
       BNE FR9     ; FORCED
FR3    STX TEMP3
       SEC
       LDA PRI4,Y
       SBC TEMP0
       TAX
       LDA RAM,X
       NOP
       LDA PRI4,Y   ; RAM!
       STY TEMP0
       CLC
       LDA TEMP3
       ADC TEMP0
       TAY
       LDX #30
FR8    LDA TY,X
       BMI FR9
       DEX
       BNE FR8
FR9    TYA
       BMI CRO1
       TXA
       BEQ CRO1
       TAX
       LDA RAM,X
       NOP
       LDA PRI1,Y   ; RAM!
       TAY
       LDX TEMP1
       LDA RAM,X
       NOP
       LDA TY,Y     ; RAM!
       LDX TEMPX
       LDA RAM,X
       NOP
       LDA OBX,Y    ; RAM!
       LDX TEMPY
       LDA RAM,X
       NOP
       LDA OBY,Y    ; RAM!
       STY TEMP0
CRO2   JSR RND
       AND #NANG
       TAX
       LDY TEMP0
       LDA ANGLES,X
       TAX
       LDA RAM,X
       NOP
       LDA ODX,Y    ; RAM!
       JSR RND
       AND #NANG
       TAX
       LDY LAST.OBJ
       LDA ANGLES,X
       CMP ODY,Y
       BEQ CRO2
       LDY TEMP0
       TAX
       LDA RAM,X
       NOP
       LDA ODY,Y    ; RAM!
       STY LAST.OBJ
       CLC
       RTS
CRO1   SEC
       RTS
;
;      ERASE/DRAW MISSILES
;
DROM   LDX #1
DROM0  STX TEMP1
       STY OBJ
DROM1  LDX MX,Y
       TXA
       AND #7
       STA TEMP0
       TXA
       LDX MY,Y
       LSR
       LSR
       LSR
       TAY
       LDA SCRH,Y
       STA ADR1+1
       CLC
       TXA
       ADC SCRL,Y
       STA ADR1
       LDY TEMP0
       LDA MSHP,Y
       LDY #0
       EOR (ADR1),Y
       TAX
       LDA RAM,X
       LDA (ADR1),Y ; RAM!
       DEC TEMP1
       BMI DROM2
       LDY TEMP0
       AND MSHPI,Y
       BEQ MU1
       LDX OBJ
       LDA #$FF
       STA MISS.HIT,X
       BNE DROM2   ; FORCED
MU1    LDX OBJ
       DEC MISS.DECAY,X
       BEQ DROM2
       LDY OBJ
       JSR MXYINC
       JSR MXYINC
       JMP DROM1
DROM2  LDY OBJ
       RTS
;
;      SHAPES FOR MISSILE
;
MSHP   hex 8040201008040201
MSHPI  hex C0E070381C0E0703
;
;      MOVE MISSILES
;
MXYINC TYA
       TAX
       LDA MDX,X
       AND #$F0
       CLC
       ADC MXF,X
       STA MXF,X
       LDA MDX,X
       AND #$0F
       ADC MX,X
       SEC
       SBC #$04
       AND #$7F
       STA MX,X
       LDA MDY,X
       AND #$F0
       CLC
       ADC MYF,X
       STA MYF,X
       LDA MDY,X
       AND #$0F
       ADC MY,X
       SEC
       SBC #$04
       BPL 1$
       LDA #79
1$     CMP #80
       BCC 2$
       LDA #0
2$     STA MY,X
       RTS
;
;      MOVE OBJECT IN
;      PRIORITY TABLES
;
MOVE   LDA RATE
       BPL 1$
       LDA HITS
       EOR #MAX.HIT
       STA RATE
1$     LDA TEMPTY
       BNE .6
       LDY OBJ.COUNT
       DEY
       BPL 2$
       LDY #9
2$     STY OBJ.COUNT
       LDA PRI1,Y
       BMI 3$
       JSR UPD
3$     LDA PRI2,Y
       BMI 4$
       JSR UPD
4$     LDA PRI3,Y
       BMI 5$
       JSR UPD
5$     RTS
.6     JMP CRAST
UPD    TAY
       JSR DROBJ
       JSR XYINC
       JSR DROBJ
       LDY OBJ.COUNT
       RTS
;
;      ERASE/DRAW OBJECT
;      IN Y.
;
DROBJ  STY OBJ
       LDX OBX,Y
       TXA
       AND #$7
       STA TEMP0
       TXA
       LDX OBY,Y
       LSR
       LSR
       LSR
       TAY
       LDA SCRH,Y
       STA ADR1+1
       LDA SCRH+1,Y
       STA ADR2+1
       LDA SCRH+2,Y
       STA ADR3+1
       CLC
       TXA
       ADC SCRL,Y
       STA ADR1
       CLC
       TXA
       ADC SCRL+1,Y
       STA ADR2
       CLC
       TXA
       ADC SCRL+2,Y
       STA ADR3
       LDX OBJ
       LDY TY,X
       LDA TYL,Y
       STA ADR4
       LDA TYH,Y
       STA ADR4+1
       LDX TEMP0
       JMP (ADR4)
SAST   TXA
       ASL
       ADC TEMP0
       TAX
       ADC #<SMASTL
       STA SHAPES
       LDA #>SMASTL
       ADC #0
       STA SHAPES+1
       TXA
       ADC #<SMASTR
       STA SHAPES+2
       LDA #>SMASTR
       ADC #0
       STA SHAPES+3
       LDY #SZVSAST
       BNE MAST1    ; FORCED
MAST   TXA
       ASL
       ASL
       ASL
       TAX
       ADC #<MDASTL
       STA SHAPES
       LDA #>MDASTL
       ADC #0
       STA SHAPES+1
       TXA
       ADC #<MDASTR
       STA SHAPES+2
       LDA #>MDASTR
       ADC #0
       STA SHAPES+3
       LDY #SZVMAST
MAST1  JMP SMASTD
LAST   TXA
       ASL
       ADC TEMP0
       ASL
       ASL
       TAX
       ADC #<LASTL
       STA SHAPES
       LDA #>LASTL
       ADC #0
       STA SHAPES+1
       TXA
       ADC #<LASTM
       STA SHAPES+2
       LDA #>LASTM
       ADC #0
       STA SHAPES+3
       TXA
       ADC #<LASTR
       STA SHAPES+4
       LDA #>LASTR
       ADC #0
       STA SHAPES+5
       LDY #SZVLAST
LAST1  LDA (SHAPES),Y
       EOR (ADR1),Y
       TAX
       LDA RAM,X
       LDA (ADR1),Y ; RAM!
       LDA (SHAPES+2),Y
       EOR (ADR2),Y
       TAX
       LDA RAM,X
       LDA (ADR2),Y ; RAM!
       LDA (SHAPES+4),Y
       EOR (ADR3),Y
       TAX
       LDA RAM,X
       LDA (ADR3),Y ; RAM!
       DEY
       BPL LAST1
       JMP ENDDR
;
;      ALIEN MOVEMENT
;
ALN    JSR WDIS
       JSR ALM
       JSR WENA
       LDY OBJ
       LDX DX
       LDA RAM,X
       NOP
       LDA ODX,Y    ; RAM!
       LDX DY
       LDA RAM,X
       NOP
       LDA ODY,Y    ; RAM!
       LDA TEMP0
       ASL
       ASL
       ADC TEMP0
       TAX
       ADC #<ALNL
       STA SHAPES
       LDA #>ALNL
       ADC #0
       STA SHAPES+1
       TXA
       ADC #<ALNR
       STA SHAPES+2
       LDA #>ALNR
       ADC #0
       STA SHAPES+3
       LDY #SZVALN
SMASTD LDA (SHAPES),Y
       EOR (ADR1),Y
       TAX
       LDA RAM,X
       LDA (ADR1),Y ; RAM!
       LDA (SHAPES+2),Y
       EOR (ADR2),Y
       TAX
       LDA RAM,X
       LDA (ADR2),Y ; RAM!
       DEY
       BPL SMASTD
ENDDR  LDY OBJ
SHP    RTS
;
;      END OF CODE.
;      START OF (GASP!) DATA!
;
;
;
;         SCREENEQUUATES
;
;
;
;
;
; TYPE:
;      0 PLAYER SHIP
;      1 SMALL ASTEROID
;      2 MEDIUM ASTEROID
;      3 LARGE ASTEROID
;      4 ALIEN
;
TYL    .byte #SHP,#SAST,#MAST,#LAST,#ALN
TYH    .byte #>SHP,#>SAST,#>MAST,#>LAST,#>ALN
SIZEH  .byte #SZHSHP+3,#SZHSAST+3
       .byte #SZHMAST+3,#SZHLAST+3
       .byte #SZHALN+3
SIZEV  .byte #SZVSHP+1,#SZVSAST+1
       .byte #SZVMAST+1,#SZVLAST+1
       .byte #SZVALN+1
SCRL   .byte #TB2,#TB3,#TB4,#TB5
       .byte #TB6,#TB7,#TB8,#TB9
       .byte #TB10,#TB11,#TB12
       .byte #TB13,#TB14,#TB15
       .byte #TB16,#TB17,#TB2,#TB3
SCRH   .byte >TB2,>TB3,>TB4,>TB5
       .byte >TB6,>TB7,>TB8,>TB9
       .byte >TB10,>TB11,>TB12
       .byte >TB13,>TB14,>TB15
       .byte >TB16,>TB17,>TB2,>TB3
;
;
;      SHAPES FOR METEROIDS
;
;
;
;
;
;
;  SHAPE FOR SMALL ASTEROID
;
;
;
;
SZHSAST    EQU 3
SZVSAST    EQU 2
SMASTL
       hex 609060304830182418
       hex 0C120C060906030403
       hex 010201000100
SMASTR
       hex 000000000000000000
       hex 000000000000008000
       hex 804080C020C0
;
;
;   SHAPE FOR MEDIMUM ASTEROID
;
;
;
;
SZHMAST    EQU 7
SZVMAST    EQU 7
MDASTL
       hex 3443408086444428
       hex 0530404122201805
       hex 0A12122220201906
       hex 000C0A1110080402
       hex 0001010B08080601
       hex 0102020001020200
       hex 0000020201000000
       hex 0000000101000000
MDASTR
       hex 0000008080000000
       hex 0080800000808000
       hex 000000C020208000
       hex 0060901010206080
       hex A010100808101060
       hex 40300888040418A0
       hex 30CC0202A2242428
       hex 28C48401112AC600
;
;
;  SHAPE FOR LARGE ASTEROID
;
;
;
;
SZHLAST    EQU 15
SZVLAST    EQU 11 ;
LASTL
       hex 050808588080804040201806
       hex 001126404020402020100C03
       hex 050810102020201020100500
       hex 0001020810081010100A0000
       hex 000102040808080A00000000
       hex 000001020204010000010000
       hex 000001020100000202010000
       hex 000000000001010000000000
LASTM
       hex 806010080804040468404080
       hex C03008040402040202648800
       hex 00A842010201010102824428
       hex A01215000000010001848850
       hex 284404040100000080818A50
       hex 2A8100010100008080008354
       hex 14610000008080000000A10A
       hex 16212010A000008080402806
LASTR
       hex 000000000000000000000000
       hex 000000000000000000000000
       hex 000000000000000000000000
       hex 000000808080008000000000
       hex 000000004040404080000000
       hex 000080000080204040800000
       hex 004020101040402010208000
       hex 004020101008085080404080
;
;
;   SHAPE FOR ALIEN SHIP
;
;
;
;
SZHALN EQU 6
SZVALN EQU 4
ALNL
       hex 3CC3661800
       hex 1E61330C00
       hex 0F30190600
       hex 07180C0300
       hex 030C060100
       hex 0106030000
       hex 0003010000
       hex 0001000000
ALNR
       hex 0000000000
       hex 0080000000
       hex 00C0800000
       hex 8060C00000
       hex C030608000
       hex E01830C000
       hex F00C986000
       hex 7886CC3000
;
;      TABLE FOR SIZE OF
;      ASTEROIDS
;
PRIT   hex FF04070C0C
;
R2END  EQU .
;
;
;      SCREEN       (RAM)
; ALSO POWER UP INITALIZE IS
; OUT IN FIRST SCREEN CLEAR
;
;
;
;
       ORG $F800,0
       RORG $f800  ; RAM1
R3START
;
;
;
;
;      VARIABLES    (RAM)
;
PRI1   ds  10
PRI2   ds  10
PRI3   ds  10
PRI4   ds  10
TY     ds  31
;      RANDOM NUMBER GENERATOR
;
RND    LDA RNDL
       LSR
       LSR
       SBC RNDL
       LSR
       ROR RNDH
       ROR RNDL
       LDA RNDL
       RTS
;
TB1    ds  85
TB2    ds  86
TB3    ds  85
TB4    ds  85
TB5    ds  86
TB6    ds  85
TB7    ds  85
TB8    ds  86
TB9    ds  85
TB10   ds  85
TB11   ds  86
TB12   ds  85
TB13   ds  85
TB14   ds  86
TB15   ds  85
TB16   ds  85
TB17   ds  86
OBX
START  LDX #$FF
       TXS
       LDA #6
       STA P2CONT
       LDA #$31
       STA PFCONT
       STA PF1
       JSR RESET.SCREEN
       ADC STICK
       ADC TIMER
       STA RNDL
       STA RNDH
       LDA #10
       STA CLOBJ
       STA SVAL
       LDX #1
       STX GAME
       STX SET.PLAYER
       DEX         ; X=0
       STX PLAYER
       STX NPLAY
       STX ATTRACT
       STX SEL.FLAG
       JSR RND
       JMP MAIN
OBY    EQU OBX+31
       ds  OBY+31-.
OBXF   ds  31
OBYF   ds  31
ODX    ds  31
ODY    ds  31
;
;      INCREMENT XY OF
;      AN OBJECT IN Y REG
;
XYINC  LDA ODX,Y
       AND #$F0
       CLC
       ADC OBXF,Y
       TAX
       LDA RAM,X
       NOP
       LDA OBXF,Y   ; RAM!
       LDA ODX,Y
       AND #$0F
       ADC OBX,Y
       SEC
       SBC #$04
       AND #$7F
       TAX
       LDA RAM,X
       NOP
       LDA OBX,Y    ; RAM!
       LDA ODY,Y
       AND #$F0
       CLC
       ADC OBYF,Y
       TAX
       LDA RAM,X
       NOP
       LDA OBYF,Y   ; RAM!
       LDA ODY,Y
       AND #$0F
       ADC OBY,Y
       SEC
       SBC #$04
       BPL XY1
       LDA #78-SZVLAST
XY1    CMP #79-SZVLAST
       BCC XY2
       LDA #0
XY2    TAX
       LDA RAM,X
       NOP
       LDA OBY,Y    ; RAM!
XY3    RTS
;
;      BONE-HEAD SWAPS
;
DROBJ2 JSR RAM2E
       JSR DROBJ
       JMP RAM1E
SHIP.SWAP
       JSR RAM2E
       JSR MXYINC
       LDX #0
       JSR DROM0
       JMP RAM1E
ALIEN.SWAP
       JSR RAM2E
       JSR CAL
       JMP RAM1E
XPLOS.SWAP
       JSR RAM2E
       JSR XPLOS
       JMP RAM1E
SELECT.SWAP
       JSR R2WD
       JSR RSEL
       JMP R1WE
SETOPT.SWAP
       JSR R2WD
       JSR SETOPT
       JMP R1WE
DPLAY.SWAP
NSHIP.SWAP
       JSR RAM1E
;
; THIS JSR IS MODIFED
; TO GOTO DNSHIP OR DPLAY
;
SC1    JSR DNSHIP
;
;
SWAP.CHANGE1 EQU SC1+1
       JMP RAM2E
SCORE.SWAP
       JSR RAM1E
       JSR SCOREN
       JMP RAM2E
R2WD   JSR WDIS
       JMP RAM2E
R1WE   JSR WENA
       JMP RAM1E
;
;      MAIN EVERYTHING
;
MAIN   JSR RAM1E
       JSR MAIN2
       JSR BKG      ; R2
       JSR RAM1E
       JSR DRAW1    ; R1
       JSR WENA
       JSR USHP     ; R1
       JSR ALIEN    ; R1
       JSR MAIN2
       JSR RAM1E
       JSR DRAW2    ; R1
       JSR WENA
       JSR RAM2E
       JSR SCORE    ; R2
       JSR CHECK    ; R2
       JSR MISMV    ; R2
MAIN1  INC FRAMEL
       BNE 1$
       INC FRAMEH
1$     JMP MAIN
;
;      SECOND MAIN LOOP
;
MAIN2  JSR SYNC    ; R1
       JSR RAM2E
       JSR MOVE    ; R2
       JSR WDIS
       JMP SOUND   ; R2
;
;      DRAW 1 FIELD OF SCREEN
;        (TWO FRAMES)
;
SCREEN PHP
       STA TAR
       STX TXR
       STY TYR
       LDA STATUS
       PHA
       SEC          ; SET ; SCREEN
       ROR SCRN.FLAG
       JSR SYNC
       JSR WDIS
       JSR DRAW2
       JSR SYNC
       JSR DRAW1
       CLC          ; CLR ; SCREEN
       ROL SCRN.FLAG
       PLA
       JSR SW2
       LDY TYR
       LDX TXR
       LDA TAR
       PLP
       RTS
;
;      RAM1 ENABLE
;
RAM1E  LDA STATUS
       AND #$EF
       BNE SW2      ; FORCED
;
;      RAM2 ENABLE
;
RAM2E  LDA STATUS
       ORA #$10
       BNE SW2      ; FORCED
;
;      WRITE DISABLE ROUTINE
;
WDIS   LDA STATUS
       AND #$FD
       BNE SW2      ; FORCED
;
;      WRITE ENABLE ROUTINE
;
WENA   LDA STATUS
       ORA #$2
;
       NOP
SW2    STA STATUS
       TAX
       LDA RAM,X
;      LDA SET.STATUS
       RTS
R3END  EQU .
RAM1   EQU R1END
RAM2   EQU R2END
RAM3   EQU R3END
ZERO   EQU ZPEND


; Starpath tape header information:
        org     $10800,0
        dc.w    START
        dc.b    $0F             ; RAM bank select control

; We don't have to send all 6K.  If the program's smaller, so is the tape.
        dc.b    24              ; number of 256 byte blocks to send in a 6K image

        dc.b    $00             ; checksum (computed by tape tool)

        dc.b    $00             ; Multiload index number (0 for single-load games or first load)
        dc.w    $224            ; speed of progress bars for a 6K tape image

; Checksums for the individual 256 byte blocks are recalculated by the tape
; generation software.  Ignore warnings about the checksums being wrong.
; That's there only to verify the accuracy of transcribed audio tapes.

; 256 byte bank offsets for the image data to load into.  Just leave these
; as-is.
        ORG     $10810,0
        hex     00 04 08 0c 10 14 18 1c 01 05 09 0d 11 15 19 1d
        hex     02 06 0a 0e 12 16 1a 1e

        ORG $108ff
        .byte 0

;        bsave $E800,$2100,2600Demo.bin
        end

